/*
Hex by Ben G
Copyright (c) 2006 Ben Gilmore

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

client
	Move()
		return
	command_text = "say "
	script = {"<STYLE>BODY {background-color:"white";font-family:"Trebuchet MS";font-size:10px;color:"black";}IMG.icon {width: 16px; height: 16px}</STYLE>"}

atom
	text = " "

turf
	table
		name = ""
		icon = 'tabletop.png' //I kind of took a screenshot of blank tiles over the background and added a border in Photoshop,
							  //so if you move the grid, it's not going to look good.

var
	list
		paths = list("red" = list(), "blue" = list()) //global list of paths - explained more indepth in titanEngine.dm
		hexes = list() //list of all hex coordinates associated with a hex tile
		wins = list("red" = list(1=list(),2=list()), "blue" = list(1=list(),2=list())) //a list used to determine if a path stretches the board
		queue = list() //queue for waiting players
		players = list() //the players
	turn
	picked
	obj
		redName //this pointer makes it easier to remove the names after a game
		blueName

obj
	hex
		var
			row
			column
			list/objects = list()
		icon = 'hex.dmi'

		New(r, c, road)
			name = "[r],[c]"
			icon_state = "unclaimed"
			src.row = r
			src.column = c
			hexes["[r],[c]"] = src
		Click()
			if((players.len==2)&&(!turn)&&(usr.key==players[1])&&(!picked)) //this is the condition for the first "swap" tile placement of the game
				src.icon_state = "red"
				determinePaths(src)
				picked=1
				for(var/mob/M in world)
					if(M.key == players[2])
						switch(alert(M,"Which color would you like to play?",,"Red","Blue"))
							if("Red")
								var/list/temp = list("red", "blue")
								temp["red"] = M.key
								temp["blue"] = players[1]
								players=temp
								world << "<b>[M.key] has chosen to play as <font color=red>red</font>!</b>"
							else
								var/list/temp = list("red", "blue")
								temp["red"] = players[1]
								temp["blue"] = players[2]
								players = temp
								world << "<b>[M.key] has chosen to play as <font color=blue>blue</font>!</b>"
						var //adds the names of players to the upper corners of the board
							dmifont/Inkpen2Script22pt/name=new
							obj/R=new()
							obj/B=new()
							finalRed = players["red"]
							finalBlue = players["blue"]

						if(length(finalRed) >= 12)
							finalRed = copytext(finalRed, 1, 11) + "..."
						if(length(finalBlue) >= 12)

							finalBlue = copytext(finalBlue, 1, 11) + "..."

						name.QuickText(R,finalRed,"#FFF",,,,,justify=DF_JUSTIFY_CENTER)
						name.QuickText(B,finalBlue,"#FFF",,,,,justify=DF_JUSTIFY_CENTER)
						B.loc = locate(3,17,1)
						R.loc = locate(10,17,1)
						blueName = B //easy object references for later deletion
						redName = R
						break
				turn = players["blue"]
				world << "<b>It is now <font color=blue>[turn]'s</font> turn."

			else
				if((turn==usr.key)&&(src.icon_state=="unclaimed")) //normal tile placement
					src.icon_state = "[thisTurn(turn)]"
					determinePaths(src)
					if((players.len==2)&&(players[1]=="red")&&(players[2]=="blue"))
						turn = players[nextTurn(turn)]
						world << "<b><font color=[src.icon_state]>[players[nextTurn(turn)]]</font> places a tile at ([src.row],[src.column]).</b>"
						world << "<b>It is now <font color=[thisTurn(turn)]>[turn]'s</font> turn."

proc
	Win()
		world<<"<b>[turn] wins!</b>"
		var/scores[0]
		scores["[turn]"] = 1
		scores["[((turn==(players["red"])?(players["blue"]):(players["red"])))]"] = 0
		byondhub.ReportScores(scores) //submit scores to the hub
		sleep(20) //leave the board up for a few seconds for admiration
		reset()
	nextTurn(k) //color of the player whose turn is next, using a key name as argument
		if(players["red"] == k)
			return "blue"
		else return "red"
	thisTurn(k) //color of the player whose turn is currently active, using a key name as argument
		if(players["red"] == k)
			return "red"
		else return "blue"
	reset() //resets the board to a new game status
		picked = 0
		turn = null
		paths = null
		paths = list("red" = list(), "blue" = list())
		for(var/obj/hex/H in world)
			H.icon_state = "unclaimed" //blank tiles
		del blueName //no more names
		del redName
		for(var/mob/M in world)
			if((M.key == players["red"])||(M.key == players["blue"]))
				M.removePlayingVerbs() //take playing verbs away from last game's participants
		players.len = 0
		for(var/i=1 to 2) //add waiting players to the game
			if(i <= queue.len)
				for(var/mob/M in world)
					if(M.key == queue[i])
						players += M.key
						world << "<b>[M.key] is ready to play!</b>"
						if(players.len == 2)
							world << "<b><center>[players[1]] vs [players[2]]</center></b>"
							world << "<b>[players[1]] will now place a <font color=red>red</font> piece and then [players[2]] will choose a color."
							break
		for(var/i=1 to 2)
			if(!queue.len) break
			queue -= queue[1]
	resignUser(mob/M) //wah I quit
		if(((players.len == 2) && ((players["red"]==M.key)||(players["blue"]==M.key)))||(picked))
			switch(alert("Are you sure you wish to resign?",,"Yes","No"))
				if("Yes")
					world << "<b>[M.key] resigns!"
					turn = ((players["red"]==M.key)?(players["blue"]):(players["red"]))
					Win()
				else
					return
		else if((players.len) && (!("red" in players))&&(M.key in players))
			world << "<b>[M.key] has left the player queue!"
			players -= M.key
			M.removePlayingVerbs()
			if(queue.len)
				players += queue[1]
				queue -= queue[1]
				world << "<b>[players[players.len]] has been added from the queue!</b>"
				if(players.len == 2)
					world << "<b><center>[players[1]] vs [players[2]]</center></b>"
					world << "<b>[players[1]] will now place a <font color=red>red</font> piece and then [players[2]] will choose a color."
			if(!players.len) reset()

		else
			world << "<b>[M.key] has left the player queue!"
			if(!(M.key in queue))
				players -= M.key
				M.removePlayingVerbs()
			else
				queue -= M.key
				usr.removePlayingVerbs()
	generateWinLists() //see titanEngine.dm
		var/list/redWins = wins["red"]
		var/list/blueWins = wins["blue"]
		for(var/i=1 to n)
			redWins[1] += "[i],1"
		for(var/i=1 to n)
			redWins[2] += "[22-i],[i]"
		for(var/i=11 to n*2-1)
			blueWins[1] += "[i],1"
		for(var/i=1 to n)
			blueWins[2] += "[i],[i]"

mob
	density = 0
	Stat() //updates the stat panel with a global list of people and their current positions
		var/list
			statPlayers = list()
			statQueue = list()
			statObservers = list()
		for(var/mob/M in world)
			if(M.key in players)
				statPlayers += M
			else if((players["red"] == M.key)||(players["blue"]==M.key))
				statPlayers+=M
			else if(M.key in queue)
				continue
			else
				statObservers += M
		for(var/m in queue)
			for(var/mob/M in world)
				if(M.key == m)
					statQueue += M
		statpanel("Users","---Players---")
		for(var/mob/M in statPlayers)
			statpanel("Users",M.key)
		statpanel("Users","---In Queue---")
		for(var/mob/M in statQueue)
			statpanel("Users","[M.key] - [queue.Find(M.key)]\th")
		statpanel("Users","---Observers---")
		for(var/mob/M in statObservers)
			statpanel("Users",M.key)
	proc
		removePlayingVerbs()
			src.verbs += /mob/verb/JoinGame
			src.verbs -= typesof(/mob/playing/verb)
		addPlayingVerbs()
			src.verbs -= /mob/verb/JoinGame
			src.verbs += typesof(/mob/playing/verb)
	Login()
		..()
		usr << "<b><center><font size=6>HEX</font><br><font size=3><i>by Ben G</i></font></center>"
		world << "<b>[src.key] has connected!"
		src.loc=locate(7,9,1)
		if((!src.client.address)||(src.client.address==world.address)) //host verbs
			src.verbs += typesof(/mob/admin/verb)
	Logout()
		..()
		world << "<b>[src.key] has disconnected!"
		if(((players.len == 2) && ((players["red"]==src.key)||(players["blue"]==src.key)))||(picked))
			turn = ((players["red"]==src.key)?(players["blue"]):(players["red"]))
			Win()
		else resignUser(src)
		del src

mob
	playing
		verb
			resign()
				set name = "Resign"
				resignUser(usr)
	verb
		JoinGame()
			set name = "Join Queue"
			if(players.len >= 2)
				if(!(usr.key in queue))
					world << "<b>[usr.key] is [queue.len+1]\th in the queue!"
					queue += usr.key
					addPlayingVerbs()
					return
			else
				addPlayingVerbs()
				players += usr.key
				world << "<b>[usr.key] is ready to play!</b>"
				if(players.len == 2)
					world << "<b><center>[players[1]] vs [players[2]]</center></b>"
					world << "<b>[players[1]] will now place a <font color=red>red</font> piece and then [players[2]] will choose a color."
		Say(t as text)
			if(t)
				world << "<b>[usr.key]</b>:  [censor_html(t)]"
		Who()
			for(var/mob/M in world)
				usr << M.key
		Rules()
			usr<<browse({"
<b><center>Rules of Hex</b><br><i>Courtesy of Wikipedia</i></center><p>
Players have two colors, say "Red" and "Blue" (the colors are conventional and may vary from version to version).
They take turns placing a piece of their own color on a hexagon. Red's goal is to form a red path connecting two opposite
sides of the parallelogram, and Blue aims to connect the other two sides. Each of the four hexagons in the corners belong to
two sides.</p><p>
The first player in the queue will be able to place a red piece anywhere on the board they like.  After this, the second player
will be able to choose to play red or blue.  This provides complete statistical fairness.</p>
"})