/***************** Environment/Ecosystem Library *****************/
  /********************** Made by Albro1 **********************/


/*
Hello, I have made this library in the hopes to instill some more realism in BYOND games.
I'm sure you've seen all those games - even games as small as Pokemon - that have things like seasons, weather, and interesting AI.
With this library, creating these things is almost too easy.  This library comes with some helpful built-in functions and
	also shows you some examples of how to do many things.  Since I did not want to separate each little thing into separate
	files, I have conveniently set up this simple system that requires minimal editing on your part to include:

		-STEPS TO INCLUDE LIBRARY-
			1. Make sure you have Deadron's Event Loop library downloaded.  The link is below, right above it's #include statement.
			2. Make sure map.dmm is NOT included.
			3. For most projects, you will want to make sure you comment(type //) out DEBUG_OUTPUT, SHOW_EXAMPLES, and MOB_DEBUG.
				* DEBUG_OUTPUT has no real use unless you are experienced and have a reason to use it.
					NOTE - DEBUG_OUTPUT may cause some initial startup lag when running this library.  It is avoidable,
						 but removing it would be easier. Just give it a few seconds and everything will be fine.
				* SHOW_EXAMPLES includes things such as my simple AI system.  They may cause some conflicts, which is why I
					recommend removing it.
				* MOB_DEBUG does very little other than give the mob some small features to test the systems.
					They have no real use to a public project.
	-IMPORTANT LIBRARY INFORMATION-
		*Definitions*
			--MOB_LOOP--
				As long as MOB_LOOP is defined, all /mobs created will be added to the list of Receivers.
				Their base_EventCycle() proc is called every tick (1/10 of a second).
				Remove this #define statement to stop all mobs from being added.

			--OBJ_LOOP--
				This does the exact same thing as the above MOB_LOOP, however it is for /objs.

			--SEASONAL_LOOP--
				As long as SEASONAL_LOOP is defined, the included code that deals with Seasons and season control will work.
				There isn't much reason NOT to include this, unless it seriously conflicts with your project.
				The system is a little sensitive and involves a lot of everything else.

			--DYNAMIC_ICONS--
				As long as this is defined, my special icon functions will be included.  Most of these only correspond with
				the season, so without SEASONAL_LOOP, this wont do a whole lot without some editing on your part(Which I don't
				recommend unless you know what you are doing.).  So, tl;dr, if you include this, it is almost a necessity to
				have SEASONAL_LOOP included.

				The format for these icons is:
					"[icon state]_[season]_[wear-and-tear]"
						icon state    : This is what you would normally name it.  Ex: grass.
						season        : This is the season, in all lowercase text.
						wear-and-tear : The higher this is, the better condition the icon is.  As it is worn it will decrease.

	There is not very much commenting in this library, but I recommend looking through world.dm and obj.dm first.
	These files contain most of the code, and you should take the time to familiarize yourself with it.
	This library provides you some good systems and some good functions, but to get the most out of it you will need to
	use the library to add things yourself.  Follow my AI example with my deer.  Create some interesting animals.
	Create a bear that will hunt down a deer.  Make the deer respond to being hunted(If it notices the bear) by running away.
	You can easily go into great detail concerning AI.  I provided a very simple example for you to learn from.

	Yes, I do use braces in my code.  It isn't that complicated.  I use it mainly to force myself to organize the code more.
	In case you don't understand:

mob
{ << This brace starts the /mob definition stack.
	var
	{ << This brace would start a mob/var definition stack.
		var1; << The semicolon is put at the end of each line.  It doesn't do anything, it is merely habit.  It is required in some other programming languages, however.
	} << This brace closes the mob/var definition stack, putting you back to the /mob definition stack.
} << This brace closes the /mob definition stack.


	-DISCLAIMER-
		This library was made by me, and Event Loop, used in the library was made by Deadron.  Each are the intellectual
		property of their creators.  By uploading this library to the hub I give usage rights to any who download it.
		I would like to be credited for my work spent on this library if you include it.
		If you touch any of these files and break something, I recommend using the Undo button(Control+Z on a Windows Computer),
		because I am not fixing it.  If you cannot fix it, then go to your BYOND lib folder and delete this library.  Then
		go back to the hub and download it again.  This will give you a fresh copy once again.



*/


// This is a necessary inclusion.  If you don't have Deadron's Event Loop library, download it here:
// http://www.byond.com/developer/Deadron/EventLoop
#include <deadron\eventloop\eventloop.dme>
// Comment this if you don't want mobs to have an EventLoop.
#define MOB_LOOP
// Comment this if you don't want objs to have an EventLoop.
#define OBJ_LOOP
// Comment this is you don't want seasonal control.
#define SEASONAL_LOOP
// Comment this to remove debugging output.
#define DEBUG_OUTPUT
// Comment this to remove dynamic icons.  Dynamic icons are the icons that have multiple states, allowing them to look as if
//  they have been eaten or worn away.
#define DYNAMIC_ICONS
// Comment this to remove all example codes that may not work when you plug this into your project.
#define SHOW_EXAMPLES
// Comment this to remove all debugging verbs and other things.
#define MOB_DEBUG