atom/movable
	var
		walk=0
		walk_away=0
		walk_rand=0
		walk_to=0
		walk_towards=0
		x_dist=1
		y_dist=1
		atomsize=1
proc
	PathAssignment()
		for(var/obj/o in world)
			if(o.dense)
				for(var/turf/t in view(0,o))
					t.nonpathable=1
atom/proc
	C_North(atom/movable/a)
		C_Pixel_Move(a,0,a.adjustment)
	C_South(atom/movable/a)
		C_Pixel_Move(a,0,-a.adjustment)
	C_East(atom/movable/a)
		C_Pixel_Move(a,a.adjustment,0)
	C_West(atom/movable/a)
		C_Pixel_Move(a,-a.adjustment,0)
	C_Northwest(atom/movable/a)
		C_Pixel_Move(a,-a.adjustment,a.adjustment)
	C_Northeast(atom/movable/a)
		C_Pixel_Move(a,a.adjustment,a.adjustment)
	C_Southwest(atom/movable/a)
		C_Pixel_Move(a,-a.adjustment,-a.adjustment)
	C_Southeast(atom/movable/a)
		C_Pixel_Move(a,a.adjustment,-a.adjustment)

	C_Pixel_Get_Dist(atom/movable/source,atom/movable/target,axis="x")
		if(axis=="x")
			if(source.x_max<target.x_min)
				var/distance=target.x_min-source.x_max
				source.x_dist=distance
				return
			if(source.x_min>target.x_max)
				var/distance=source.x_min-target.x_max
				source.x_dist=distance
				return
			else
				source.x_dist=0
				return
		if(axis=="y")
			if(source.y_max<target.y_min)
				var/distance=target.y_min-source.y_max
				source.y_dist=distance
				return
			if(source.y_min>target.y_max)
				var/distance=source.y_min-target.y_max
				source.y_dist=distance
				return
			else
				source.y_dist=0
				return

	C_Pixel_Function_Clear(atom/movable/reference,exception)
		if(reference.walk&&exception!="walk")
			reference.walk=0
		if(reference.walk_away&&exception!="walk_away")
			reference.walk_away=0
		if(reference.walk_rand&&exception!="walk_rand")
			reference.walk_rand=0
		if(reference.walk_to&&exception!="walk_to")
			reference.walk_to=0
		if(reference.walk_towards&&exception!="walk_towards")
			reference.walk_towards=0

	C_Pixel_Walk(atom/movable/reference,direction,lag=1)
		set background=1
		reference.walk=1
		C_Pixel_Function_Clear(reference,"walk")
		while (reference.walk)
			sleep(lag)
			if(direction==NORTH)
				C_North(reference)
			if(direction==SOUTH)
				C_South(reference)
			if(direction==EAST)
				C_East(reference)
			if(direction==WEST)
				C_West(reference)
			if(direction==NORTHEAST)
				C_Northeast(reference)
			if(direction==NORTHWEST)
				C_Northwest(reference)
			if(direction==SOUTHEAST)
				C_Southeast(reference)
			if(direction==SOUTHWEST)
				C_Southwest(reference)

	C_Pixel_Walk_Away(atom/movable/reference,atom/movable/target,max,lag)
		set background=1
		C_Pixel_Function_Clear(reference,"walk_away")
		reference.walk_away=1
		while (reference.walk_away)
			sleep(lag)
			C_Pixel_Get_Dist(reference,target,"x")
			C_Pixel_Get_Dist(reference,target,"y")
			if(reference.x_dist>=max||reference.y_dist>=max)
				reference.walk_away=0
				return
			else
				if(reference.x_dist>reference.y_dist)
					if(reference.x_max<target.x_min)
						C_West(reference)
					if(reference.x_min>target.x_max)
						C_East(reference)
				if(reference.y_dist>reference.x_dist)
					if(reference.y_max<target.y_min)
						C_South(reference)
					if(reference.y_min>target.y_max)
						C_North(reference)
				else
					if(reference.x_max<target.x_min)
						if(reference.y_max<target.y_min)
							C_Southwest(reference)
						if(reference.y_min>target.y_max)
							C_Northwest(reference)
					if(reference.x_min>target.x_max)
						if(reference.y_max<target.y_min)
							C_Southeast(reference)
						if(reference.y_min>target.y_max)
							C_Northeast(reference)

	C_Pixel_Walk_Rand(atom/movable/reference,lag=1,walkdist=8)
		set background=1
		reference.walk_rand=1
		C_Pixel_Function_Clear(reference,"walk_rand")
		while (reference.walk_rand)
			sleep(lag)
			var/number=walkdist
			var/random=rand(1,8)
			if(random==1)
				while(number>0)
					sleep(lag)
					C_North(reference)
					number--
			if(random==2)
				while(number>0)
					sleep(lag)
					C_South(reference)
					number--
			if(random==3)
				while(number>0)
					sleep(lag)
					C_East(reference)
					number--
			if(random==4)
				while(number>0)
					sleep(lag)
					C_West(reference)
					number--
			if(random==5)
				while(number>0)
					sleep(lag)
					C_Northwest(reference)
					number--
			if(random==6)
				while(number>0)
					sleep(lag)
					C_Southwest(reference)
					number--
			if(random==7)
				while(number>0)
					sleep(lag)
					C_Northeast(reference)
					number--
			if(random==8)
				while(number>0)
					sleep(lag)
					C_Southeast(reference)
					number--

	C_Pixel_Walk_To(atom/movable/reference,atom/target,min,lag)
		set background=1
		reference.walk_to=1
		C_Pixel_Function_Clear(reference,"walk_to")
		while (reference.walk_to)
			sleep(lag)
			C_Pixel_Get_Dist(reference,target,"x")
			C_Pixel_Get_Dist(reference,target,"y")
			if(reference.x_dist<=min&&reference.y_dist<=min)
				reference.walk_to=0
				return
			else
				if(reference.atomsize==1)
					var/dest=locate(target.x,target.y,target.z)
					var/refloc=locate(reference.x,reference.y,reference.z)
					var/path[]=AStar(refloc,dest,/turf/proc/GetAdjacentTurfs,/turf/proc/GetDistance)
					if(path.len>0)
						var/turf/next=path[2]
						if(reference.x<next.x)
							C_East(reference)
						if(reference.x>next.x)
							C_West(reference)
						if(reference.y<next.y)
							C_North(reference)
						if(reference.y>next.y)
							C_South(reference)
				if(reference.atomsize==2)
					var/dest=locate(target.x,target.y,target.z)
					var/refloc=locate(reference.x,reference.y,reference.z)
					var/path[]=AStar(refloc,dest,/turf/proc/BigGetAdjacentTurfs,/turf/proc/GetDistance)
					if(path.len>0)
						var/turf/next=path[2]
						if(reference.x<next.x)
							C_East(reference)
						if(reference.x>next.x)
							C_West(reference)
						if(reference.y<next.y)
							C_North(reference)
						if(reference.y>next.y)
							C_South(reference)
				/*if(reference.x_dist<reference.y_dist)
					if(reference.x_max<target.x_min)
						C_East(reference)
					if(reference.x_min>target.x_max)
						C_West(reference)
				if(reference.y_dist<reference.x_dist)
					if(reference.y_max<target.y_min)
						C_North(reference)
					if(reference.y_min>target.y_max)
						C_South(reference)
				if(reference.y_dist==0)
					if(reference.x_max<target.x_min)
						C_East(reference)
					if(reference.x_min>target.x_max)
						C_West(reference)
				if(reference.x_dist==0)
					if(reference.y_max<target.y_min)
						C_North(reference)
					if(reference.y_min>target.y_max)
						C_South(reference)
				else
					if(reference.x_max<target.x_min)
						if(reference.y_max<target.y_min)
							C_Northeast(reference)
						if(reference.y_min>target.y_max)
							C_Southeast(reference)
					if(reference.x_min>target.x_max)
						if(reference.y_max<target.y_min)
							C_Northwest(reference)
						if(reference.y_min>target.y_max)
							C_Southwest(reference)*/

	C_Pixel_Step_Away(atom/movable/reference,atom/movable/target)
		C_Pixel_Function_Clear(reference)
		C_Pixel_Get_Dist(reference,target,"x")
		C_Pixel_Get_Dist(reference,target,"y")
		if(reference.x_dist>reference.y_dist)
			if(reference.x_max<target.x_min)
				C_West(reference)
			if(reference.x_min>target.x_max)
				C_East(reference)
		if(reference.y_dist>reference.x_dist)
			if(reference.y_max<target.y_min)
				C_South(reference)
			if(reference.y_min>target.y_max)
				C_North(reference)
		else
			if(reference.x_max<target.x_min)
				if(reference.y_max<target.y_min)
					C_Southwest(reference)
				if(reference.y_min>target.y_max)
					C_Northwest(reference)
			if(reference.x_min>target.x_max)
				if(reference.y_max<target.y_min)
					C_Southeast(reference)
				if(reference.y_min>target.y_max)
					C_Northeast(reference)

	C_Pixel_Step_Rand(atom/movable/reference,lag=1)
		C_Pixel_Function_Clear(reference)
		var/random=rand(1,8)
		if(random==1)
			C_North(reference)
		if(random==2)
			C_South(reference)
		if(random==3)
			C_East(reference)
		if(random==4)
			C_West(reference)
		if(random==5)
			C_Northwest(reference)
		if(random==6)
			C_Southwest(reference)
		if(random==7)
			C_Northeast(reference)
		if(random==8)
			C_Southeast(reference)

	C_Pixel_Step_Towards(atom/movable/reference,atom/movable/target)
		C_Pixel_Function_Clear(reference)
		C_Pixel_Get_Dist(reference,target,"x")
		C_Pixel_Get_Dist(reference,target,"y")
		if(reference.x_dist<reference.y_dist)
			if(reference.x_max<target.x_min)
				C_East(reference)
			if(reference.x_min>target.x_max)
				C_West(reference)
		if(reference.y_dist<reference.x_dist)
			if(reference.y_max<target.y_min)
				C_North(reference)
			if(reference.y_min>target.y_max)
				C_South(reference)
		if(reference.y_dist==0)
			if(reference.x_max<target.x_min)
				C_East(reference)
			if(reference.x_min>target.x_max)
				C_West(reference)
		if(reference.x_dist==0)
			if(reference.y_max<target.y_min)
				C_North(reference)
			if(reference.y_min>target.y_max)
				C_South(reference)
		else
			if(reference.x_max<target.x_min)
				if(reference.y_max<target.y_min)
					C_Northeast(reference)
				if(reference.y_min>target.y_max)
					C_Southeast(reference)
			if(reference.x_min>target.x_max)
				if(reference.y_max<target.y_min)
					C_Northwest(reference)
				if(reference.y_min>target.y_max)
					C_Southwest(reference)