#define DETECTION_AREA 2 //Alter this to changethe distance at which collisions are detected.

atom/movable
	animate_movement=0   //don't use byond's default animation movement

atom
	var
		x_shifts=0           //stores the number of shifts on the x-axis the atom undergoes to determine when their actual mob is moved
		y_shifts=0           //stores the number of shifts on the y-axis the atom undergoes to determine when their actual mob is moved
		y_min=1              //bottom edge of bounding box
		y_max=32             //top edge of bounding box
		x_min=1              //left edge of bounding box
		x_max=32             //right edge of bounding box
		width=32             //width of the icon (used to adjust y/x maxes/mins)
		height=32            //height of the icon (used similarly as above)
		adjustment=4         //determines the number of pixels that the atom's icon moves
		dense=0              //determines if the atom can collide with the object or not
		can_move=1           //determines if an atom is allowed to move or not

atom/proc
	C_Bounding_Box_Calculation(atom/a,boxwidth=32,boxheight=32,x_offset=0,y_offset=0)
		if(boxwidth<=1||boxheight<=1||x_offset<0||y_offset<0)            //it has to be at least 2px wide and tall
			CRASH("Detected value for width/height or offsets is impossible, crashing procedure")
		var/minxcalc=a.x*32-31+x_offset                   //divide the current byond grid x-coordinate into pixels
		var/minycalc=a.y*32-31+y_offset                   //divide the current byond grid y-coordinate into pixels
		a.x_min=minxcalc
		a.x_max=minxcalc+(boxwidth-1)
		a.y_min=minycalc
		a.y_max=minycalc+(boxheight-1)

	C_Pixel_Move(atom/movable/a,x_move,y_move)
		var/final_direction                      //stores what the icon's final direction will be
		if(x_move>0&&y_move>0)                   //if the x and y axis are both increased then the new direction is northeast
			final_direction=NORTHEAST
		if(x_move>0&&y_move==0)                  //if only the x axis is increased the direction is east
			final_direction=EAST
		if(x_move>0&&y_move<0)                   //if the x axis is increased and the y axis is decreased then the direction is southeast
			final_direction=SOUTHEAST
		if(x_move<0&&y_move>0)                   //if the x axis is decreased and the y axis is increased the new direction is northwest
			final_direction=NORTHWEST
		if(x_move<0&&y_move==0)                  //if only the x axis is decreased the direction is west
			final_direction=WEST
		if(x_move<0&&y_move<0)                   //if both the x and y axis are decreased the direction is southwest
			final_direction=SOUTHWEST
		if(x_move==0&&y_move>0)                  //if the x axis is unchanged and the y axis is increased the direction is North
			final_direction=NORTH
		if(x_move==0&&y_move<0)                  //if only the y axis is decreased the direction is south
			final_direction=SOUTH
		a.dir=final_direction                    //set the direction of the atom to the value of the placeholder "final_direction"
		var/new_x=a.pixel_x+x_move               //calculate the shift of the atom's icon by x_move pixels on the x-axis
		var/new_y=a.pixel_y+y_move               //calculate the shift the atom's icon by y_move pixels on the y-axis
		a.x_min=(a.x_min+x_move)                 //calculate and set the new position of the left edge of the bounding box
		a.x_max=(a.x_max+x_move)                 //calculate and set the new position of the right edge of the bounding box
		a.y_max=(a.y_max+y_move)                 //calculate and set the new position of the top edge of the bounding box
		a.y_min=(a.y_min+y_move)                 //calculate and set the new position of the bottom edge of the bounding box
		C_Pixel_Collision_Handling(a)            //check for collisions up ahead
		C_Pixel_Map_Check(a)                     //check to make sure you don't move off the map
		if(a.can_move)                           //if there is no collision
			a.pixel_x=new_x                      //adjust the pixel-x of the atom's icon
			a.pixel_y=new_y                      //adjust the pixel-y of the atom's icon
			a.x_shifts+=x_move                   //add up the x-shifts for mob handling
			a.y_shifts+=y_move                   //add up the y-shifts for mob handling
			if(istype(a,/mob/))
				C_Camera_Handling(a,x_move,y_move)
			C_Pixel_Mob_Handling(a)              //pass the procedure on to mob handling
		else
			a.can_move=1
			a.x_min=(a.x_min-x_move)             //this portion of code resets the bounding box position if there is failed movement
			a.x_max=(a.x_max-x_move)
			a.y_max=(a.y_max-y_move)
			a.y_min=(a.y_min-y_move)

	C_Pixel_Collision_Handling(atom/movable/source)
		if(source.dense)                                                           //if the source is dense
			for(var/atom/obstruction in range(DETECTION_AREA,source))              //for all atoms within range of the source atom
				if(!obstruction.dense||obstruction==source)                        //if the atom isn't dense ignore it
					continue
				if(source.y_min>obstruction.y_max||source.y_max<obstruction.y_min) //if the atom is above or below the obstruction no collision occurs
					continue
				if(source.x_min>obstruction.x_max||source.x_max<obstruction.x_min) //if the atom is to the left or right of the obstruction no collision occurs
					continue
				C_Pixel_Bump(source,obstruction)

	C_Pixel_Bump(atom/a,atom/b)
		a.can_move=0                          //this is the default function for C_Pixel_Bump()