#define SAVE_MINIMAPS

var/dc_MinimapStates

atom/var
	dc_MinimapState
	dc_MinimapPriority=0

proc/dc_GenerateMinimap(x1=1,y1=1,x2=world.maxx,y2=world.maxy,z=1,ResX=1,ResY=1)
	set background=1

	var
		list/parts = list()
		icon/result = icon('dc_MinimapBlank.dmi',"")
		list/orderList = list()
		list/drawList = list()
		atom/A
		i = 1
		X;Y
	result.Crop(1,1,(x2-x1+1)*ResX,(y2-y1+1)*ResY)
	result.DrawBox("#000000",1,1,(x2-x1+1)*ResX,(y2-y1+1)*ResY)

	//Pre-cache Minimap states for faster drawing
	if(dc_MinimapStates)
		for(var/S in icon_states(dc_MinimapStates))
			parts[S] = icon(dc_MinimapStates,S)
	else world.log<<"WARNING: dc_MinimapStates not set to icon file! Generator will accept colors only!"

	//Loop through all turfs in the Minimap's area and add any necessary objects
	//Set any aside with dc_MinimapPriority settings to be drawn on the second run through
	for(var/turf/T in block(locate(x1,y1,z),locate(x2,y2,z)))

		A = T // First atom is the turf itself
		i = 0 // Consider that index '0'
		do
			if(i) A = T.contents[i]

			if(A.dc_MinimapState)
				if(!A.dc_MinimapPriority)
					// No priority needed, just add to list
					drawList += A
				else
					//Sort into orderList based on priority, to be drawn later
					var/pos=1
					for(,pos<=orderList.len,pos++)
						var/atom/C = orderList[pos]
						if(C.dc_MinimapPriority>A.dc_MinimapPriority) break
					orderList.Insert(pos,A)
		while(++i<=T.contents.len)

	// Add the priority items to the end of the list, to be drawn on top
	drawList += orderList

	// Loop through the objects to draw
	for(A in drawList)
		if(text2ascii(A.dc_MinimapState,1)==35) //35=# -> RGB value
			X=(A.x-x1)*ResX+1;Y=(A.y-y1)*ResY+1
			result.DrawBox(A.dc_MinimapState,X,Y,X+ResX-1,Y+ResY-1)
		else if(A.dc_MinimapState in parts)
			result.Blend(parts[A.dc_MinimapState],ICON_OVERLAY, (A.x-x1+1)*ResX-16,(A.y-y1+1)*ResY-16)

	return result