world/New()//when world is created..
	de_create_mini_map_layout()
	..()//continue with normal stuff than
	//de_create_mini_map_layout() //create the mini map

var
	list/DE_MAP_Z_SCAN = list(1,2,3,4) //The mini-map generator will scan these z-levels and create mini maps for them.
	const
		DE_MAP_LAYOUT_LAYER = MOB_LAYER+5//controls the layer which the pins for the map tracker will show up on.
		DE_MAP_UPDATE_DELAY = 15//this is the update delays for all pins in case you want to slow them down a bit or whatever it is u want to do.

//***********************************************************
//************ No need to bother these vars below ***********
//***********************************************************
	list/de_mini_tracker = new/list()
	list/pin_tracker = new/list()
	list/href_scan = new/list()
	de_wait_scan = 1
//***********************************************************
//***********************************************************
//***********************************************************

DE_MM
	parent_type = /obj
	de_mini_map
		var/tmp
			list/maps_parts = new/list()
			obj/main_map = null
	de_map_piece
		var/tmp
			de_z
		name = "Map"
		icon = 'grid.dmi'
		icon_state = "grid"


proc
	de_create_mini_map_layout()
		set background = 1
		if(length(DE_MAP_Z_SCAN))
			var
				max_wx = world.maxx
				max_wy = world.maxy
				xer = 1
				yer = 1
			if(max_wx > 32)
				while(max_wx > 32)
					max_wx -= 32
					xer ++
			if(max_wy > 32)
				while(max_wy > 32)
					max_wy -= 32
					yer ++
			for(var/scan_this_z in DE_MAP_Z_SCAN)
				if(scan_this_z > world.maxz) break
				var/DE_MM/de_map_piece/S = new/DE_MM/de_map_piece
				S.layer = TURF_LAYER
				S.screen_loc = "mini_map:1,1"
				S.de_z = "[scan_this_z]"
				for(var/x = 1, x <= xer, x++)
					for(var/y = 1, y <= yer, y++)
						var
							icon/I = new('grid.dmi',"grid")
							xx = (32 * x)
							yy = (32 * y)
						if(xx > world.maxx) xx = world.maxx
						if(yy > world.maxy) yy = world.maxy
						for(var/turf/T in block(locate(((32 * x) - 31),((32 * y) - 31),scan_this_z),locate(xx,yy,scan_this_z)))
							if(!T) continue
							var/dx = (((T.x - 1) - (32 * x)) + 33)
							var/dy = (((T.y - 1) - (32 * y)) + 33)
							if(!T.icon)
								I.DrawBox(rgb(1,1,1),dx,dy,dx,dy)
							else if(("[T.type]" in href_scan))
								var/plist[] = params2list(href_scan["[T.type]"])
								I.DrawBox(rgb(text2num(plist["r"]),text2num(plist["g"]),text2num(plist["b"])),dx,dy,dx,dy)
							else
								var/icon/G = new(T.icon)
								var/list/most_pixels = new/list()
								for(var/gi = 1, gi <= 32, gi++)
									for(var/gi2 = 1, gi2 <= 32, gi2++)
										var/gp = G.GetPixel(gi, gi2, "[T.icon_state]")
										if(gp) most_pixels["[gp]"] ++
								if(length(most_pixels))
									var/pn = "#000000"
									var/hp = 0
									for(var/ch in most_pixels)
										if(most_pixels["[ch]"] > hp||(most_pixels["[ch]"] == hp) && prob(50))
											pn = "[ch]"
											hp = most_pixels["[ch]"]
									if(hp)
										var/list/hexs = new/list()
										hexs = hex2rgb("[pn]")
										if(length(hexs))
											href_scan["[T.type]"] = "r=[hexs[1]]&g=[hexs[2]]&b=[hexs[3]]"
											I.DrawBox(rgb(text2num(hexs[1]),text2num(hexs[2]),text2num(hexs[3])),dx,dy,dx,dy)
								del(G)
						S.overlays += image(I, layer = (TURF_LAYER + 1), pixel_x = ((32 * x) - 32), pixel_y = ((32 * y) - 32))
						del(I)
				var/DE_MM/de_map_piece/E = new/DE_MM/de_map_piece
				E.layer = TURF_LAYER
				E.screen_loc = "mini_map:[xer],[yer]"
				E.de_z = "[scan_this_z]"
				var/DE_MM/de_mini_map/N = new/DE_MM/de_mini_map
				N.contents.Add(S, E)
				N.maps_parts.Add(S, E)
				N.main_map = S
				de_mini_tracker["[scan_this_z]"] = N
		de_wait_scan = 0

client
	New()
		while(de_wait_scan) sleep(25)//wait till mini maps are loaded.
		..()

atom/movable
	var/tmp
		de_pin_enable = 0 //setting this to one will create mini map pin when a atom is created hence. New()
		de_pin_icon = null //this is the mini map pins icon.
		de_pin_icon_state = null//this is the mini map pins icon_icon_state.

//************ No need to bother these vars below ***********
		de_updated = 0
		image/de_my_pin = null
//***********************************************************
	proc
		de_create_pin()
			src.de_my_pin = new/image
			src.de_my_pin.icon = src.de_pin_icon
			src.de_my_pin.name = "[src.name]"
			src.de_my_pin.layer = DE_MAP_LAYOUT_LAYER
			src.de_my_pin.icon_state = "[src.de_pin_icon_state]"
			src.de_my_pin.pixel_x = (src.x - 8)
			src.de_my_pin.pixel_y = (src.y - 8)
			pin_tracker += src.de_my_pin
			var/DE_MM/de_mini_map/N = de_mini_tracker["[src.z]"]
			if(N) src.de_my_pin.loc = N.main_map
			for(var/mob/C in world)
				if(!C||!C.client||!C.de_map_is_up) continue
				C.de_update_map_layout()
		de_pin_uppydate()
			if(src.de_my_pin)
				if(!src.de_updated)
					src.de_updated = 1
					spawn(DE_MAP_UPDATE_DELAY)
						if(src.de_my_pin)
							src.de_my_pin.pixel_x = (src.x - 8)
							src.de_my_pin.pixel_y = (src.y - 8)
						src.de_updated = 0
		de_remove_pin()
			if(src.de_my_pin)
				if((src.de_my_pin in pin_tracker))
					pin_tracker.Remove(src.de_my_pin)
				del(src.de_my_pin)
	New()
		..()
		if(src.de_pin_enable)//if create a pin car is on the atom.
			while(de_wait_scan) sleep(25)//wait til mini maps are loaded.
			src.de_create_pin()//create the mini map pin.
	Del()
		src.de_remove_pin()
		..()
	Move()
		var/old_z = "[src.z]"
		.=..()
		if(.)//if move was succesful
			if(src.de_my_pin)//if we have a pin
				if(old_z != "[src.z]")
					var/DE_MM/de_mini_map/N = de_mini_tracker["[src.z]"]
					if(N) src.de_my_pin.loc = N.main_map
					else src.de_my_pin.loc = null
					if(ismob(src))
						var/mob/M = src
						M.de_update_map_layout()
				src.de_pin_uppydate()

mob
	var
		de_map_is_up = 0
	proc
		de_update_map_layout(var/uf = 0)
			if(src.client)
				if(src.de_map_is_up)
					if(length(de_mini_tracker))
						if(uf)
							for(var/DE_MM/de_map_piece/M in src.client.screen)
								if(!M) continue
								src.client.screen.Remove(M)
						else
							for(var/DE_MM/de_map_piece/M in src.client.screen)
								if(!M) continue
								if("[M.de_z]" != "[src.z]")
									src.client.screen.Remove(M)
							var/DE_MM/de_mini_map/N = de_mini_tracker["[src.z]"]
							if(N)
								for(var/DE_MM/de_map_piece/O in N.maps_parts)
									if(!O||(O in src.client.screen)) continue
									src.client.screen.Add(O)
							for(var/image/I in pin_tracker)
								if(!I||(I in src.client.images)) continue
								src.client.images.Add(I)