
// This demo file is included with the upContainers Library
// Version 2.0

obj/fruit
	apple
	orange
	banana
	kiwi
	pineapple
	coconut

mob/verb

	Set_test()

		src << "<b>Set Example #1</b>\n"

		var/Set/Univ = new /Set (list(1,2,3,4,5,6,7,8,9), univ=SET_UNIVERSAL)

		var/Set/A = new /Set (list(1,2,3,4,5), univ=Univ)
		var/Set/B = new /Set (list(3,4,5,6,7), univ=Univ)
		var/Set/C = new /Set (list(5,6,7,8,9), univ=Univ)
		var/Set/X = new /Set (univ=Univ)

		src << "Universal set U = [Univ.toString()]"
		src << "A = [A.toString()]"
		src << "B = [B.toString()]"
		src << "C = [C.toString()]"
		src << "X = [X.toString()] (the null set)"

		var/Set/I = set_Intersection(A, B)
		var/Set/J = set_Complement(A, B)
		var/Set/K = set_Complement(A)	// calculate absolute complement by not supplying the second arg
		var/Set/L = set_Union(A, set_Union(B, C))

		var/Set/M = set_Complement(set_Union(A, B));
		var/Set/N = set_Intersection(set_Complement(A), set_Complement(B));

		src << null

		src << "A intersects B = [I.toString()]"
		src << "A complements B = [J.toString()]"
		src << "A' = [K.toString()]"
		src << "A union B union C = [L.toString()]"
		src << "Demonstrating DeMorgan's Law using sets: (A union B)' = A' intersects B'"
		src << "  [M.toString()] = [N.toString()]"

		src << null


	Set_test2()

		src << "<b>Set Example #2</b>\n"

		src << "You can also create objects using sets, and change the comparison \
				operator by supplying the path of a proc you want to use to compare \
				two objects.  If you are working with instances and consider \
				two objects of the same type equal, then you should pass<tt>/proc/setSameType</tt> through \
				the constructor of the Set datum."

		src << null

		var/Set/Univ = new /Set (newlist(/obj/fruit/apple, /obj/fruit/orange, /obj/fruit/banana,
										/obj/fruit/kiwi, /obj/fruit/pineapple, /obj/fruit/coconut),
								  /proc/setSameType, univ=SET_UNIVERSAL)
		var/Set/A = new /Set(newlist(/obj/fruit/apple, /obj/fruit/banana), /proc/setSameType, Univ)
		var/Set/B = new /Set(newlist(/obj/fruit/pineapple, /obj/fruit/coconut), /proc/setSameType, Univ)

		src << "Universal set U = [Univ.toString()]"
		src << "A = [A.toString()]"
		src << "B = [B.toString()]"

		src << null

		var/Set/O = set_Union(A, B);
		var/Set/P = set_Complement(B)

		src << "A union B = [O.toString()]"
		src << "B' = [P.toString()]"

		src << null


	Stack_test()

		src << "<b>Stack Example</b>\n"

		var/Stack/S = new /Stack (list(1,2,3,4,5))
		src << "The introductory textbook usage of a stack is to iterate through a list backwards by \
				popping until the stack is empty, and displaying the \"popped\" item on top.  \
				First in, last out."

		src << null

		src << "S = [S.toString()]"

		src << "Iterating backwards:"
		while(!S.isEmpty())
			src << S.Pop()

		src << null


	Queue_test()

		src << "<b>Queue Example</b>\n"

		var/Queue/Q = new /Queue (list(1,2,3,4,5))

		src << "A queue can be thought of as a line.  The first person to enter the line is \
				the first person to be served.  First in, first out."
		src << "Q = [Q.toString()]"

		src << "Iterating forwards:"
		while(!Q.isEmpty())
			src << Q.Dequeue()

		src << null

	Deque_test()

		src << "<b>Deque Example</b>\n"

		var/Deque/S = new /Deque (list(4,5,2,6,3))

		src << "A deque is a container poppable and pushable from both sides \
				of the line.  This allows either a nice mix of stack and queue functionality, \
				or the flexibility of both without needing two structures."

		src << "S = [S.toString()]"

		src << null

		src << "S.PushFront(2)"
		src << "S.PushBack(4)"

		src << null

		S.PushFront(2)
		S.PushBack(4)

		src << "S = [S.toString()]"

		src << "Iterating backwards (popping from the back):"
		while(!S.isEmpty())
			src << S.PopBack()

		src << null


	Linked_List_test()

		src << "<b>Linked List Example</b>\n"

		var/LinkedList/L = new /LinkedList (list(1,2,3,4,5))

		src << "L = [L.toString()]"

		src << null

		var/lNode/first = L.getFront()
		src << "L.getFront().getData(): [first.getData()]"

		src << null

		src << "Iterating from the front to back: "
		for(var/lNode/n = L.getFront(), n != null, n = n.getNext())
			src << n.getData()

		src << null

		src << "Deleting the front two entries in list"

		L.DeleteFront()
		L.DeleteFront()

		src << "L = [L.toString()]"

		src << null

		src << "Iterating from the front to back after first two elements deleted: "
		for(var/lNode/n = L.getFront(), n != null, n = n.getNext())
			src << n.getData()

		src << null


	Doubly_Linked_List_test()
		set name = "Doubly-Linked List test"

		src << "<b>Doubly-Linked List Example</b>\n"

		var/DLinkedList/L = new /DLinkedList (list(1,2,3,4,5))

		src << "L = [L.toString()]"

		src << null

		src << "Iterating from the front to back: "
		for(var/dlNode/n = L.getFront(), n != null, n = n.getNext())
			src << n.getData()

		src << null

		src << "Deleting the front and back of the list"

		L.Delete(L.getFront())
		L.Delete(L.getBack())

		src << "L = [L.toString()]"

		src << null

		src << "Iterating from the back to front after first and last element deleted: "
		for(var/dlNode/n = L.getBack(), n != null, n = n.getPrev())
			src << n.getData()

		src << null


