
#define upContainers_VERSION 		2.0
#define upContainers_CRASH(msg)		CRASH("upContainers error: [msg]")

/*
	-----------------------------------------------------------------

	upContainers v2.0
	by: Unknown Person

	-----------------------------------------------------------------

	upContainers is a library that defines commonly used primitive
	data stuctures.  The library currently supports sets, stacks,
	and queues.

	Documentation for each structure is located in its respective
	code file.

	Structure			Type Path(s)			File
	-----------------------------------------------------------------
	Stack				/Stack					stack.dm
	Queue				/Queue					queue.dm
	Set					/Set					set.dm
	Deque				/Deque					deque.dm
	Linked List			/LinkedList		/lNode	linkedlist.dm
	Doubly-Linked List	/DLinkedList	/dlNode	linkedlistdouble.dm
	-----------------------------------------------------------------

	Release Info:

	Version 1.0 (May 9th, 2008)
	 - library released (features sets, queues, and stacks)

	Version 2.0 (May 31st, 2008)
	 - Added the Linked List (/LinkedList) and Doubly-
	   Linked List structure (/DLinkedList), which utilizes the
	   Linked Node structures (/lNode and /dlNode) to store data
	 - Added the Deque structure (/Deque), which allows pushing and
	   popping from both sides of the line. (IainPeregrine, Hiead)
	 - Added the /Set/Copy(), which returns a duplicate of
	   a set
	 - Empty sets and queues would give a runtime error on
	   getTop(), getFront(), and getBack() (Thurnok)
	 - Sets, Queues, and Stacks now support single-item initialization
	   If a non-list value is submitted through the first arg, the
	   container object will be initialized with the single value.
	   (Thurnok)
	 - Stacks, Sets and Queues did not properly assign an internal
	   list if an initializer list was sent through New()

	-----------------------------------------------------------------
*/

proc
	isSet(Set/S)
		return istype(S, /Set)

	isStack(Stack/S)
		return istype(S, /Stack)

	isQueue(Queue/Q)
		return istype(Q, /Queue)

	isLinkedList(LinkedList/L)
		return istype(L, /LinkedList)

	islNode(lNode/N)
		return istype(N, /lNode)

	isdlNode(dlNode/N)
		return istype(N, /dlNode)

