proc/censor_attributes(t,list/allowed_attributes)
	var/list/tags = _get_tags(t)
	if(!tags || !tags.len) return t
	var/result = t
	for(var/elem in tags)
		var/start_pos = text2num(elem)
		var/end_pos   = tags[elem]
		//> and < stripped
		var/tag = copytext(result,start_pos + 1,end_pos)
		//Don't try censoring a closing tag or an "empty" tag
		if(!tag || text2ascii(tag,1) == 47 || text2ascii(tag,length(tag)) == 47) continue
		tag = _del_invalid_spaces(tag)
		var/list/in_tag_words = _get_in_tag_words(tag)
		if(in_tag_words) for(var/tagword_start_text in in_tag_words)
			var/tagword_start = text2num(tagword_start_text)
			var/text_tagword = copytext(tag,tagword_start,in_tag_words[tagword_start_text] + 1)
			var/attribute = copytext(text_tagword,1,findtext(text_tagword,"="))
			//extremely hacky workaround
			if(text2ascii(attribute,1) == text2ascii(" ")) attribute = copytext(attribute,2,0)
			if(!allowed_attributes || !(attribute in allowed_attributes))
				result = _hc_string_replace(result,text_tagword,"")
	return result