//return t with all tags that aren't in allowed_tags html_encode()d
proc/censor_html(t,list/allowed_tags,list/allowed_attributes,censor_tags = 1,censor_attributes = 1)
	ASSERT(istext(t))
	var/result = t
	if(censor_tags)
		if(!allowed_tags || !allowed_tags.len) return _html_tag_encode(result)
		var/list/tags = _get_tags(result)
		var/changes_made = 0
		while(tags && tags.len)
			//update tags -- positions will have changed
			if(changes_made)
				tags = _get_tags(result)
				changes_made = 0
			var/start_pos = text2num(tags[1])
			var/end_pos   = tags[tags[1]]
			//the tag with > and < stripped out
			var/tag = copytext(result,start_pos + 1,end_pos)
			//If it's a closing tag
			var/tag_start_pos = 1
			//ASCII 47 is a forwards slash (/)
			if(text2ascii(tag,1) == 47) tag_start_pos = 2
			tags.Cut(1,2)
			if(!(copytext(tag,tag_start_pos,findtext(tag," ")) in allowed_tags))
				//the tag with > and < included
				var/full_tag = copytext(result,start_pos,end_pos + 1)
				result = _hc_string_replace(result,full_tag,_html_tag_encode(full_tag))
				changes_made = 1
	//censor attributes
	if(censor_attributes) result = censor_attributes(result,allowed_attributes)
	return result