/*The purpose of the HTML Censor library is to allow your program to go
through text, escaping some HTML tags, and allowing others. It does the
same for attributes!

Of course, it erases disallowed attributes -- they can't be escaped the
way that tags can!

Note: If you see a proc that starts with an underscore in this
library, then it is an internal proc of the library's: you don't
have to worry about it!

proc/censor_html(t,list/allowed_tags,list/allowed_attributes,censor_tags = 1,censor_attributes = 1)

	Arguments:
		t                  (string to be censored)

		allowed_tags       (a list of HTML tags to be allowed, and not escaped. The "<" and ">"
		                    signs should not be used when defining this argument)

		allowed_attributes (see allowed_tags. Unlike allowed_tags, if an HTML attribute is found
		                    in t, and it is not included in this list, that attribute and its
		                    value will be deleted. The tag who owns the attribute, however,
		                    will not be deleted, nor will the other attributes that belong to
		                    the tag of the deleted attributes)

		censor_tags        (Equal to 1 by default, if this argument is equal to 0, then HTML tags
		                    will not be censored. If you wanted to censor only attributes, but
		                    not tags, then this option is for you)

		censor_attributes  (See censor_tags)

	Returns:
		t, but with all disallowed tags escaped, and with all disallowed
		attributes erased.

	Example:
		The following allows <b> and <i> tags, but no attributes,
		and no other tags:

		mob/verb/Say(t as text)
			world << "[src]: [censor_html(t,list("b","i")]"

Thanks to:
- Gazoot for making _string_replace()
*/